(function(){

	Date.prototype.Format = function (fmt) {
	    var o = {
	        "M+": this.getMonth() + 1, //月份 
	        "d+": this.getDate(), //日 
	        "h+": this.getHours(), //小时 
	        "m+": this.getMinutes(), //分 
	        "s+": this.getSeconds(), //秒 
	        "q+": Math.floor((this.getMonth() + 3) / 3), //季度 
	        "S": this.getMilliseconds() //毫秒 
	    };
	    if (/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
	    for (var k in o)
	    if (new RegExp("(" + k + ")").test(fmt)) fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
	    return fmt;
	}

	var DetailView = {
		init: function() {
			var urlParmas = getUrlParmas();

			if (!urlParmas || typeof urlParmas != 'object') {
				return ;
			}

			var bundleInfo = JSON.parse(urlParmas.bundleinfo);
			this.bundleInfo = bundleInfo;
			console.log(bundleInfo);
			$('#pkg-detail').html(this.getTpl(bundleInfo));

			this.addEvent();
		},
		addEvent: function() {
			var self = this;
			$('#pkg-detail').on('click', '.pkg-detail-list .map_url', function(event) {
				var href = $(this).attr('href');
				openUrl(href);
				return false;
			});

			//安装按钮
			$('#pkg-detail').on('click', '.install_btn', function(event) {
				hybrid.bundleDebug.installBundle(function(flag){
					alert('安装成功!');
					location.href = './hdp_bundle_debug_list.html';
				},function(){
					alert('安装失败!');
				}, self.bundleInfo);
				return false;
			});
		},
		getTpl: function(bundleInfo) {

			var mapArr = [];
			if (bundleInfo.maps) {
				$.each(bundleInfo.maps, function(key, value) {
					mapArr.push('<dd class="v"><a class="map_url" href="' + key + '">' + key + '</a></dd>');
				});
			}

			var tplArr = [
				'<dl class="pkg-detail-list">',
					'<dt class="k">包名称</dt>',
		      '<dd class="v">',
		      bundleInfo.title ? bundleInfo.title : ('hdp_' + bundleInfo.id + '_' + bundleInfo.version),
		      '</dd>',
		      '<dt class="k">预览链接</dt>',
		      mapArr.join(''),
		      '<dt class="k">版本号</dt>',
		      '<dd class="v"><i>',
		      bundleInfo.version,
		      '.0.0</i></dd>',
			];

			if(bundleInfo.status == 2) {
				tplArr.push('<dt class="k">状态</dt><dd class="v">已更新</dd></dt>');
				tplArr.push('<dt class="k">安装时间</dt><dd class="v">' + new Date(bundleInfo.effectiveTimeStamp * 1000).Format("yyyy-MM-dd hh:mm:ss") + '</dd></dt>');
			}else if(bundleInfo.status == 1){
				tplArr.push('<dt class="k">状态</dt><dd class="v">未更新</dd></dt>');
			}else if (!bundleInfo.status) {
				tplArr.push('<dt class="k">状态</dt><dd class="v">已过期</dd></dt>');
				tplArr.push('<dt class="k">过期时间</dt><dd class="v">' + new Date(bundleInfo.offlineTimeStamp * 1000).Format("yyyy-MM-dd hh:mm:ss") + '</dd></dt>');
			}

			tplArr.push('</dl>');

			if (bundleInfo.status == 1) {
				tplArr.push('<div class="btn-area"><a class="btn is__offline install_btn" href="javascript:;">下载&安装离线包</a></div>');
			}

			return tplArr.join('');
		}
	}

	DetailView.init();

	/**
	 * Helpers
	 */
	
	function getUrlParmas(params,url){
      url = url || decodeURIComponent(location.href);
      
      var str = url.split('?')[1];

      if(!str) return {};

      var ret = {};

      //get all
      if(!params){
          str.split('&').forEach(function(value){
              var v = value.split('=');
              ret[v[0]] = v[1];
          });

          return ret;
      } 

      params = $.isArray(params)? params : [params];
      
      params.forEach(function(key){
          var reg = new RegExp(key + '=(.*?)&|' + key + '=(.*?)$');
          var m = str.match(reg);
          ret[key] = m ? (m[1] ? m[1] : m[2]) : null;
      });

      return ret;
  }

  function openUrl(url) {
		if (typeof mgj == 'object' && typeof mgj.navigation == 'object') {
			mgj.navigation.pushWindow(url);
		}else {
			location.href = url;
		}
	}

})();