(function(){

	Date.prototype.Format = function (fmt) {
	    var o = {
	        "M+": this.getMonth() + 1, //月份 
	        "d+": this.getDate(), //日 
	        "h+": this.getHours(), //小时 
	        "m+": this.getMinutes(), //分 
	        "s+": this.getSeconds(), //秒 
	        "q+": Math.floor((this.getMonth() + 3) / 3), //季度 
	        "S": this.getMilliseconds() //毫秒 
	    };
	    if (/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
	    for (var k in o)
	    if (new RegExp("(" + k + ")").test(fmt)) fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
	    return fmt;
	}

	var ListView = {
		init : function(){
			var self = this;

			hybrid.bundleDebug.getRemoteConfig(function(remoteInfo){
				var remoteBundleInfos = remoteInfo.bundleList;
				var htmlArr = [];

				hybrid.bundleDebug.getLocalInstallBundle(function(localBundleInfos){
					$.each(localBundleInfos, function(bundleId, bundleInfo) {
						//对比包状态
						var remoteBundleInfo = remoteBundleInfos[bundleId];
						if (remoteBundleInfo) {
							if (remoteBundleInfo.version > bundleInfo.version) {
								//超前 需要下载包
								bundleInfo.status = 1;
								bundleInfo.toVersion = remoteBundleInfo.version;
							}else {
								//正常安装状态
								bundleInfo.status = 2;
							}
							delete remoteBundleInfos[bundleId];
						}else {
							//过期
							bundleInfo.status = 0;
						}
						htmlArr.push(self.getTpl(bundleInfo));
					});

					//这个是本地没有 接口有的包信息
					$.each(remoteBundleInfos, function(bundleId, bundleInfo) {
						bundleInfo.status = 1;
						bundleInfo.toVersion = bundleInfo.version;
						htmlArr.push(self.getTpl(bundleInfo));
					});

					$('#pkg-list').html(htmlArr.join(''));
				});
			});

			this.addEvent();
		},
		addEvent : function() {
			$('#pkg-list').on('click', '.item', function(event) {
				var _this = $(this);
				var bundleInfo = _this.data('bundleinfo');
				openUrl('./hdp_bundle_debug_detail.html?bundleinfo=' + encodeURIComponent(JSON.stringify(bundleInfo)));
				return false;
			});
		},
		getTpl : function(bundleInfo){

			var itemClass = ['is__disable', 'is__online', 'is__offline'];
			var itemInstallStatus = ['已过期', '未安装/未更新', '最新包'];

			var tpl = [
				'<li class="item ' + itemClass[bundleInfo.status] + "\" data-bundleinfo='" + JSON.stringify(bundleInfo) + "'>",
					'<div class="item-cnt">',
						'<h5 class="t">',
						bundleInfo.title ? bundleInfo.title : ('hdp_' + bundleInfo.id + '_' + bundleInfo.version),
						'</h5>',
						'<div class="desc">',
							'<div class="part1">',
								'<span class="st">' + itemInstallStatus[bundleInfo.status] + '</span>',
								'<span class="time"><i class="icon-clock"></i><i>',
								new Date(bundleInfo.effectiveTimeStamp * 1000).Format("yyyy-MM-dd hh:mm:ss"),
								'</i></span>',
							'</div>',
							'<div class="part2">',
								'<span class="ver">',
									'<i><span>v </span><span>',
									bundleInfo.version,
									'.0.0</span></i>',
								'</span>',
							'</div>',
						'</div>',
					'</div>',
				'</li>'
			].join('');

			return tpl;
		}
	}

	$(document).on('deviceready', function(){
		ListView.init();
	});

	/**
	 * Helpers
	 */
	function openUrl(url) {
		location.href = url;
	}
})();