(function() {
  try {
    function rand(rate){
      if(rate > 1 || rate < 0){
        console.log('rate must be betten 0 and 1');
      }
      return (Math.random() + rate -1) >= 0;
    }
    function tracker() {
      if (window.performance && window.mgj && window.mgj.tracker) {
        var timing = window.performance.timing;

        var h5_redirect = timing.redirectEnd - timing.redirectStart;
        var h5_AppCache = timing.domainLookupStart - timing.fetchStart;
        var h5_DNS = timing.domainLookupEnd - timing.domainLookupStart;
        var h5_TCP = timing.connectEnd - timing.connectStart;
        var h5_Request = timing.responseStart - timing.requestStart;
        var h5_Response = timing.responseEnd - timing.responseStart;
        var h5_Processing = timing.domComplete - timing.domLoading;
        var h5_onLoad = timing.loadEventEnd - timing.loadEventStart;
        var h5_domContentLoadEvent = timing.domContentLoadedEventEnd - timing.domContentLoadedEventStart;
        var h5_readyTime = timing.domInteractive - timing.domainLookupStart;
        var h5_onLoadTime = timing.domComplete - timing.domainLookupStart;

        var ua = navigator.userAgent.toLowerCase();

        var isIphone = function() {
          return /iphone/i.test(ua);
        };
        var isAndroid = function() {
          return /android/i.test(ua);
        };

        var engineType = "";
        var engineVersion = "";

        if (isIphone()) {
          engineType = ua.indexOf('uiwebview') > -1 ? "uiwebview" : "wkwebview";
          var arr = ua.match(/AppleWebKit\/([\w\.]*)/i);
          if(arr !=null && arr.length >1){
              engineVersion = arr[1];
          }
        } else if (isAndroid()) {
          engineType = ua.indexOf('crosswalk') > -1 ? "xwalk" : "webview";
          if(engineType === "xwalk"){
              engineVersion = ua.match(/Crosswalk\/([\w\.]*)/i)[1];
          }else{
              var arr = ua.match(/Chrome\/([\w\.]*)/i);
              if(arr !=null && arr.length >1){
                  engineVersion = arr[1];
              }else{
                engineType = "androidwebview"
              }
          }
        }

        var currentUrl = location.href.split("?")[0];
        //去除最后一个/
        var index = currentUrl.lastIndexOf('/');

        if (index == currentUrl.length - 1) {
          currentUrl = currentUrl.substr(0, index);
        }

        //本地URL 做一次处理
        if (currentUrl.indexOf('file://') === 0 && currentUrl.indexOf('hdp_') > -1) {
          currentUrl = currentUrl.replace('/index.html', '');
          var index = currentUrl.indexOf('hdp_');
          var prefix = 'file://';

          if (index > -1) {
            var subString = currentUrl.substr(index, currentUrl.length);
          }

          currentUrl = prefix + subString;
        }
        if(window.hybrid && window.hybrid.bundle && window.hybrid.bundle.isOnline){
            hybrid.bundle.isOnline(function(isOnline){
                mgj.tracker.sendEvent('20042', {
                  engineType: engineType,
                  engineVersion: engineVersion,
                  url: currentUrl,
                  redirect: h5_redirect,
                  AppCache: h5_AppCache,
                  DNS: h5_DNS,
                  TCP: h5_TCP,
                  Request: h5_Request,
                  Response: h5_Response,
                  Processing: h5_Processing,
                  onLoad: h5_onLoad,
                  domContentLoadEvent: h5_domContentLoadEvent,
                  readyTime: h5_readyTime,
                  onLoadTime: h5_onLoadTime,
                  UA: ua,
                  isOffline: !isOnline
                });
            });
        }else{
            mgj.tracker.sendEvent('20042', {
              engineType: engineType,
              engineVersion: engineVersion,
              url: currentUrl,
              redirect: h5_redirect,
              AppCache: h5_AppCache,
              DNS: h5_DNS,
              TCP: h5_TCP,
              Request: h5_Request,
              Response: h5_Response,
              Processing: h5_Processing,
              onLoad: h5_onLoad,
              domContentLoadEvent: h5_domContentLoadEvent,
              readyTime: h5_readyTime,
              onLoadTime: h5_onLoadTime,
              UA: ua,
              isOffline: currentUrl.indexOf('file://') > -1 ? 1 : 0
            });
        }

      }
    }

    function method(){
      // 35%的概率需要打点
      if(rand(0.35)){
        tracker();
      }
    }

    function delay() {
      setTimeout(method, 300);
    }
    document.addEventListener('deviceready', delay, false);
  } catch (e) {

  }
})();