/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */


var argscheck = require('cordova/argscheck');
var exec = require('cordova/exec');

/**
 * 蘑菇街App插件
 *
 * @constructor
 */
function App() {
}
var _noop = function() {};
/**
 * 检查 本地 应用是否安装,目前只支持top
 * @param callback 回调函数 function(result)
 * 如果应用已经安装，返回
 * @param appInfo 要被检测的应用的包名或者url
 */
App.prototype.isInstalled = function (callback, appInfo) {
	var suc = _noop,
      	err = _noop;
  	if (typeof appInfo == 'function') {
	    //hdp调用，传了回调
	    suc = arguments[0];
	    err = arguments[1];
	    appInfo = arguments[2];
	} else {
	    suc = callback;
	}
    var getValue = argscheck.getValue;
    appInfo = getValue(appInfo, {});
    if(typeof appInfo != 'object') return ;
    exec(suc, err, "MGJApp", "isInstalled", [appInfo]);
};

module.exports = new App();