/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */


//cordova.define('plugins/tracker', function(require, exports, module){
var argscheck = require('cordova/argscheck');
var exec = require('cordova/exec');


/**
 * 蘑菇街打点插件
 *
 * @constructor
 */
function Tracker() {
  //channel.onOneMgjIsReady.fire();
}
var _noop = function() {};

/**
 * 发送打点事件
 * @param eventName 事件名称
 * @param eventParams 事件参数，字典
 */
Tracker.prototype.sendEvent = function (eventName, eventParams) {
	var suc = _noop,
		err = _noop;
    if (typeof eventName == 'function') {
        //hdp调用，传了回调
        suc = arguments[0];
        err = arguments[1];
        eventName = arguments[2];
        eventParams = arguments[3];
    }
    var getValue = argscheck.getValue;
    eventName = getValue(eventName, "");
    eventParams = getValue(eventParams, {});
    exec(suc, err, "MGJTracker", 'sendEvent', [eventName, eventParams]);
};

module.exports = new Tracker();
//});
